Subject: [MMUSIC] SDPCapNeg Issue #1: To Add, Delete and Replace Attributes

From: Flemming Andreasen <[email-masked]>
Date: Mon, 25 Jun 2007 13:13:12 -0400

Probably the biggest open issue we have in the SDP Capability 
Negotiation Framework at this point is the ability to replace and delete 
attributes from an actual configuration SDP when generating a potential 
configuration. At the Prague IETF, people asked for some more 
motiviation and use cases for this feature before deciding whether we 
should include it in the core capability negotiation framework or not. I 
have written a short I-D in the subject, which you can find at:

http://www.ietf.org/internet-drafts/draft-andreasen-mmusic-sdpcapneg-att-del-00.txt

Please take a look at this and let me know how you think we should 
resolve this issue. Options include:

A) Remove the ability to delete and replace attributes completely.
B) Remove the ability to delete and replace individual attributes, but 
allow for complete removal of all attributes (clean slate)
C) Keep the current ability to delete and remove individual and all 
attributes.

My personal preference is for option A, however in the interest of 
moving forward and making a reasonable compromise between functionality 
and complexity, my recommendation is option B.

Thanks

-- Flemming

_______________________________________________
mmusic mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/mmusic

---

From: Matt Lepinski <[email-masked]>
Date: Wed, 27 Jun 2007 13:47:19 -0400

Flemming,

Thanks for producing a draft that captures the motivation for deletion 
of attributes in capability negotiation.

I also think that Option (B) is a good comprise that solves the problem 
without the perception of unnecessary complexity which seems to burden 
Option (A).

The only downside of Option (B) seems to be that, unlike in Option (C), 
if deletion is used then one needs an a=acap line for attribute for 
every attribute, even those present in all potential configurations.

For example:

v=0
o=alice 2890844526 2890842807 IN IP4 10.0.0.1
s=Example SDP
t=0 0
c=IN IP4 10.0.0.1
m=audio 51000 RTP/SAVP 0 99
a=crypto:1 AES_CM_128_HMAC_SHA1_32...
a=ptime:30
a=rtpmap:99 L16/8000
a=tcap:1 RTP/AVP
a=acap:1 a=ptime:30
a=acap:2 a=rtpmap:99 L16/8000
a=pcfg:1 t=1 a=-m:1,2

The above is an offer indicating a preference for RTP, and a willingness 
to accept an S-RTP audio stream. Since we need to delete the crypto 
attribute from the potential RTP configuration (and since in Option B we 
have only clean-slate delete-all-attributes available) we need to add 
a=acap lines for the a=ptime and a=rtpmap attributes.

Adding these additional lines is a bit inefficient, but it doesn't seem 
like a serious problem to me. However, if someone has a use-case where 
deletion is required and yet the inefficiency of option (B) is 
unacceptable, then I'd be willing to support Option (C).

- Matt Lepinski :->

Flemming Andreasen wrote:

> Negotiation Framework at this point is the ability to replace and 
> delete attributes from an actual configuration SDP when generating a 
> potential configuration. At the Prague IETF, people asked for some 
> more motiviation and use cases for this feature before deciding 
> whether we should include it in the core capability negotiation 
> framework or not. I have written a short I-D in the subject, which you 
> can find at:
>
>    
> moving forward and making a reasonable compromise between 
> functionality and complexity, my recommendation is option B.
>
> Thanks
>
> -- Flemming
>
>
>
>
>
>
>
>

---

From: "Elwell, John" <[email-masked]>
Date: Fri, 29 Jun 2007 07:31:45 +0100

Me too for option B

John 

> -----Original Message-----
> From: Matt Lepinski [mailto:[email-masked]] 
> Sent: 27 June 2007 18:47
> To: Flemming Andreasen
> Cc: mmusic
> Subject: Re: [MMUSIC] SDPCapNeg Issue #1: To Add, Delete and 
> Replace Attributes
> 
> Flemming,
>